/*	Renegade Scripts.dll
	Scripts for major gameplay elements (including scripts for specific buildings, units etc)
	Copyright 2006 E!, Jonathan Wilson

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
class JFW_Team_DM_Zone : public ScriptImpClass {
	bool triggered;
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Exited(GameObject *obj,GameObject *exit);
	void Register_Auto_Save_Variables();
};

class JFW_Team_DM_Controller : public ScriptImpClass {
	int deaths;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Register_Auto_Save_Variables();
};

class JFW_Team_DM_Attatched : public ScriptImpClass {
	void Killed(GameObject *obj,GameObject *shooter);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
};

class JFW_Assault_Powerplant_Controller : public ScriptImpClass {
	bool inzone;
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj,int number);
	void Entered(GameObject *obj,GameObject *enter);
	void Exited(GameObject *obj,GameObject *exit);
	void Register_Auto_Save_Variables();
};

class JFW_Resource_Collector : public ScriptImpClass {
	int cash;
	int ID;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Register_Auto_Save_Variables();
};

class JFW_Resource_Refinery : public ScriptImpClass {
	void Entered(GameObject *obj,GameObject *enter);
};

class JFW_Resource_Field : public ScriptImpClass {
	int ID;
	void Created(GameObject *obj);
	void Entered(GameObject *obj,GameObject *enter);
	void Exited(GameObject *obj,GameObject *exit);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class JFW_Domination_Zone : public ScriptImpClass {
	unsigned int currentmodelid;
	bool enabled;
	int owner;
	void Created(GameObject *obj);
	void Entered(GameObject *obj,GameObject *enter);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class JFW_Domination_Controler : public ScriptImpClass {
	int gdizonecount;
	int nodzonecount;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class JFW_Iron_Curtain_Zone : public ScriptImpClass {
	bool enabled;
	void Created(GameObject *obj);
	void Killed(GameObject *obj,GameObject *shooter);
	void Entered(GameObject *obj,GameObject *enter);
	void Timer_Expired(GameObject *obj,int number);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Register_Auto_Save_Variables();
};

class JFW_Chrono_Controler_Zone : public ScriptImpClass {
	bool enabled;
	bool activating;
	float xpos;
	float ypos;
	float zpos;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Killed(GameObject *obj,GameObject *shooter);
	void Entered(GameObject *obj,GameObject *enter);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class JFW_Drone_Damage : public ScriptImpClass {
	bool enabled;
	void Created(GameObject *obj);
	void Damaged(GameObject *obj,GameObject *damager,float damage);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Register_Auto_Save_Variables();
};

class JFW_Conyard : public ScriptImpClass {
	bool disabled;
	void Created(GameObject *obj);
	void Killed(GameObject *obj,GameObject *shooter);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class JFW_Conyard_Vehicle_Buildings : public ScriptImpClass {
	bool disabled;
	void Created(GameObject *obj);
	void Killed(GameObject *obj,GameObject *shooter);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class JFW_Flying_Infantry : public ScriptImpClass {
	void Created(GameObject *obj);
};

class JFW_Flying_Infantry_Custom : public ScriptImpClass {
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
};

class JFW_Flying_Infantry_Powerup : public ScriptImpClass {
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
};

class JFW_Flying_Infantry_Enter : public ScriptImpClass {
	void Entered(GameObject *obj,GameObject *enter);
};

class JFW_Flying_Infantry_Exit : public ScriptImpClass {
	void Exited(GameObject *obj,GameObject *exit);
};

class JFW_Team_DM_Controller_2 : public ScriptImpClass {
	int deaths;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Register_Auto_Save_Variables();
};

class JFW_Vehicle_Thief : public ScriptImpClass {
	void Damaged(GameObject *obj,GameObject *damager,float damage);
};

class JFW_Vehicle_Thief_2 : public ScriptImpClass {
	void Damaged(GameObject *obj,GameObject *damager,float damage);
};

class JFW_Domination_Controler_End_Game : public ScriptImpClass {
	int gdizonecount;
	int nodzonecount;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class JFW_Carryable_Vehicle : public ScriptImpClass {
	void Damaged(GameObject *obj,GameObject *damager,float damage);
	void Killed(GameObject *obj,GameObject *shooter);
};

class JFW_Carry_Control : public ScriptImpClass {
	int carryall1;
	int carryall2;
	int carryall3;
	int carryall4;
	int carryall5;
	int carryall6;
	int carryall7;
	int carryall8;
	int carryall9;
	int carryall10;
	int carryall11;
	int carryall12;
	int carryall13;
	int carryall14;
	int carryall15;
	int carryall16;
	int carryall17;
	int carryall18;
	int carryall19;
	int carryall20;
	int carrycount;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Register_Auto_Save_Variables();
};

class JFW_CarryAll : public ScriptImpClass {
	bool carrying;
	int id;
	int pilotID;
	bool enabled;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Damaged(GameObject *obj,GameObject *damager,float damage);
	void Killed(GameObject *obj,GameObject *shooter);
	void Register_Auto_Save_Variables();
};

class JFW_Sensor_Array : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj,int number);
};
