/*	Renegade Scripts.dll
	Scripts for RenAlert
	Copyright 2006 Joshua "NeoSaber" Kraft, Tom "Dante" Anderson, Jonathan Wilson

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
class RA_Thief_Script: public ScriptImpClass {
	bool enabled;
	void Timer_Expired(GameObject *obj,int number);
	void Entered(GameObject *obj,GameObject *enter);
	void Created(GameObject *obj);
	void Register_Auto_Save_Variables();
};

class RA_Soviet_Defence : public ScriptImpClass {
	unsigned int id1;
	unsigned int id2;
	unsigned int id3;
	unsigned int objtype;
	void Created(GameObject *obj);
	void Enemy_Seen(GameObject *obj,GameObject *seen);
	void Action_Complete(GameObject *obj,int action,ActionCompleteReason reason);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class RA_Repair_Controller : public ScriptImpClass {
	void Killed(GameObject *obj,GameObject *shooter);
};

class RA_Repair_Script : public ScriptImpClass {
	void Entered(GameObject *obj,GameObject *enter);
	void Timer_Expired(GameObject *obj,int number);
};

class RA_Soviet_Refinery_Controller : public ScriptImpClass {
	void Killed(GameObject *obj,GameObject *shooter);
};

class RA_Soviet_Refinery_Theft_Zone : public ScriptImpClass {
	bool refinery;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Entered(GameObject *obj,GameObject *enter);
	void Exited(GameObject *obj,GameObject *exit);
	void Register_Auto_Save_Variables();
};

class RA_Allied_Thief : public ScriptImpClass {
	bool stealing;
	bool ready; // controls timer lockout of zone entry money award
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class RA_Infantry_Spy : public ScriptImpClass {
	void Created(GameObject *obj);
};

class RA_Infantry_NotSpy : public ScriptImpClass {
	void Created(GameObject *obj);
};

class RA_Helipad_Zone : public ScriptImpClass {
	void Entered(GameObject *obj,GameObject *enter);
	void Timer_Expired(GameObject *obj,int number);
};

class RA_MineLayer : public ScriptImpClass {
	int driverID;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int mesage,int param,GameObject *sender);
	void Damaged(GameObject *obj,GameObject *damager,float damage);
	void Register_Auto_Save_Variables();
};

class RA_Mine : public ScriptImpClass {
	bool AP_mine;
	bool AT_mine;
	int ownerID;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int mesage,int param,GameObject *sender);
	void Enemy_Seen(GameObject *obj,GameObject *seen);
	void Destroyed(GameObject *obj);
	void Register_Auto_Save_Variables();
};

class RA_Mine_Manager : public ScriptImpClass {
	int all_mines;
	int sov_mines;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Register_Auto_Save_Variables();
};

class RA_ObjectDeath_OnCreate : public ScriptImpClass {
	void Created(GameObject *obj);
};

class RA_Naval_Yard : public ScriptImpClass {
	int team_count;
	bool active;
	bool ready;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Killed(GameObject *obj,GameObject *shooter);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class RA_Naval_PT : public ScriptImpClass {
	int storedID;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class RA_Naval_PT_Pokable : public ScriptImpClass {
	int storedID;
	void Created(GameObject *obj);
	void Poked(GameObject *obj,GameObject *poker);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Timer_Expired(GameObject *obj,int number);
	void Register_Auto_Save_Variables();
};

class RA_Naval_Unit : public ScriptImpClass {
	void Destroyed(GameObject *obj);
};

class RA_Naval_Zone : public ScriptImpClass {
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
};

class RA_Damaged_Credits : public ScriptImpClass {
	void Damaged(GameObject *obj,GameObject *damager,float damage);
};

class RA_GameStart_Detector : public ScriptImpClass {
	void Created(GameObject *obj);
	void Killed (GameObject *obj,GameObject *shooter);
	void Timer_Expired (GameObject *obj,int number);
};

class RA_DriverDeath : public ScriptImpClass {
	void Created(GameObject *obj);
	void Timer_Expired(GameObject *obj,int number);
};

class RA_Conyard_Controller : public ScriptImpClass {
	//Clone of TDA_Conyard_Controller with a little extra
	void Created(GameObject *obj);
	void Killed(GameObject *obj,GameObject *shooter);
};

class RA_Conyard_Repair : public ScriptImpClass {
	//Clone of TDA_Conyard_Repair with a little extra
	bool Enabled;
	int objID;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Timer_Expired(GameObject *obj,int timer);
	void Register_Auto_Save_Variables();
};

class RA_ObjectDeath_OnDeath : public ScriptImpClass {
	void Killed(GameObject *obj,GameObject *shooter);
};

class RA_Demolition_Truck_Improved :public ScriptImpClass {
	int driverID;
	bool triggered;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Damaged(GameObject *obj,GameObject *damager,float damage);
	void Killed(GameObject *obj,GameObject *shooter);
	void Register_Auto_Save_Variables();
};

class RA_CTF_Zone:public ScriptImpClass {
	//clone of TDA_CTF_Zone,with a few changes
	void Entered(GameObject *obj,GameObject *enter);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Timer_Expired(GameObject *obj,int timer);
	void Created(GameObject *obj);
	void Register_Auto_Save_Variables();
	int NumCaptured;
	bool GotFlag;
	unsigned int DecorFlag;
	unsigned int FlagId;
	unsigned int PlayerId;
	bool DecorFlagPresent;
};

class RA_MAD_Tank_Improved : public ScriptImpClass {
	int driverID;
	bool deployed;
	int newobjID;
	int ownerID;
	void Created(GameObject *obj);
	void Custom(GameObject *obj,int message,int param,GameObject *sender);
	void Damaged(GameObject *obj,GameObject *damager,float damage);
	void Animation_Complete(GameObject *obj,const char *anim);
	void Destroyed(GameObject *obj);
	void Register_Auto_Save_Variables();
};

class RA_Conyard_Controller_Improved : public ScriptImpClass {
	//Clone of TDA_Conyard_Controller with a little extra
	void Created(GameObject *obj);
	void Killed(GameObject *obj,GameObject *shooter);
};

class RA_Building_DeathSound : public ScriptImpClass {
	bool halfdead;
	void Created(GameObject *obj);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Killed(GameObject *obj, GameObject *shooter);
	void Register_Auto_Save_Variables();
};

class RA_Base_Defense_Simple : public ScriptImpClass {
private:
	//These are private just for safe keeping
	unsigned long targetID; //Will store current target's ID
	bool attacking; //made true when attacking
	int current_priority; //used to over ride Actions
	float attack_timer; //attack timers use this instead of a constant
	int loop_count; //used to count loops until facing action

	void Attack(GameObject *obj, GameObject *target); 
//	GameObject* Rate_Target(GameObject *obj, GameObject *target); //Function Removed
	GameObject* Select_Target(GameObject *obj, GameObject *target);
	GameObject* Set_Target(GameObject *target);
	GameObject* Tie_Breaker(GameObject *obj, GameObject *new_target, GameObject *old_target);
//	GameObject* Get_Closest(GameObject *obj, GameObject *new_target, GameObject *old_target); //Out Dated
	bool Adjust_For_Infantry(GameObject *target);
public:
	void Created(GameObject *obj);
	void Enemy_Seen(GameObject *obj, GameObject *seen);
	void Damaged(GameObject *obj, GameObject *damager, float damage);
	void Timer_Expired(GameObject *obj, int number);
	void Action_Complete(GameObject *obj, int action, ActionCompleteReason reason);
	void Register_Auto_Save_Variables();
};
